#include "gproj.h"
#include <stdio.h>

double coords[] = 
       {5.0, 48.0,      //table
	5.0, GMapProj::DMS2DD(48,22,30),
        -77.55, 40.50,  //state college, PA
	116.23, 39.55,  //Beijing
	120.40, 30.0,   //ShaoXing, my hometown
	145.50, -35.0
       };

int testProjUTM()
{
    GProjUTM	utm;
    double x, y;
    double lon, lat;

    for(int i=0; i<sizeof(coords)/(sizeof(double)*2); i++) {
	cout<<"\n---------------- "<<coords[2*i]<<", "<<coords[2*i+1]<<"---------------\n";
	utm.init(clarke66.major, clarke66.minor, GMapProj::getUTMZone(coords[2*i]));
	cout<<utm;
	utm.forward(coords[2*i]*DEG_TO_RAD, coords[2*i+1]*DEG_TO_RAD, x, y);
	printf("forward:: x=%8.4f, y=%8.4f\n", x, y);
	utm.inverse(x,y, lon, lat);
	cout<<"inverse:: lon="<<(lon*RAD_TO_DEG)<<", lat="<<(lat*RAD_TO_DEG)<<endl;
    }


    return 0;
}

int testProjAlbers()
{
    double lon, lat, x, y;
    
    GProjAlbers alb;
    //for the Pennsylvania area.
    alb.init(clarke66.major, clarke66.minor,  //major/minor axis
	     GRADIAN(40), GRADIAN(42), 	      //1st/2nd st. parallel
	     GRADIAN(-78),GRADIAN(39));       //central lon/lat
    
    cout<<"\n-state college: "<<coords[2*2]<<", "<<coords[2*2+1]<<"---------------\n";
    cout<<alb;
    alb.forward(GRADIAN(coords[2*2]), GRADIAN(coords[2*2+1]), x, y);
    printf("forward:: x=%8.4f, y=%8.4f\n", x, y);
    alb.inverse(x,y, lon, lat);
    cout<<"inverse:: lon="<<GDEGREE(lon)<<", lat="<<GDEGREE(lat)<<endl;
    alb.inverse(-77253.869, 80389.4, lon, lat);
    cout<<"susbound (xmin,ymin)=("<<GDEGREE(lon)<<","<<GDEGREE(lat)<<")\n";

    alb.inverse(217329.549, 336048.790, lon, lat);
    cout<<"susbound (xmax,ymax)=("<<GDEGREE(lon)<<","<<GDEGREE(lat)<<")\n";
    return 0;
}

