//
// This file dumps the DBF data records in a .dbf file that comes with a
// shape file onto a console.
// Each record is a single line of comma-delimited strings.
// $Id$
//
#include <stdio.h>
#include <iostream.h>
#include <string.h>
#include <stdlib.h>
#include "gdbf.h"

void dbfDump(GDBFile* dbf, int idx)
{
    char	*rec, *field;
    int		n_records, i, j, n, s, e;
    int		vi;
    float	vf;

    if(idx<0) { //dump all
	s = 0; e = dbf->numRecords();
    } else {
	s = idx; e=idx+1;
    }

    for(i=s; i<e; i++) { 
	rec = dbf->getRecord(i);
	if(!rec) continue;	//should complain
	printf("\n");
	for(j=0; j<dbf->numFields(); j++) {
	    field = dbf->getField(j, rec);
	    switch (dbf->getFieldType(j)) {
	    case 'N':
		vf = strtod(field, NULL);
		printf("%f, ", vf);
		break;
	    case 'I':
		vi = atoi(field);
		printf("%d, ", vi);
		break;
	    default:
		printf("%s, ", field);
		break;
	    }
	}
    }
    printf("\n");
}


static int column_idx[128];
	    
main(int argc, char* argv[])
{
    if(argc <2) {
    err:	
	cerr<<"Usage: dbfdump [-i record_idx] [-c column_idx] <dbf file>\n";
	exit(1);
    }
    
    int index = -1, column_specified=0;

    for (int i=0; i<128; i++) column_idx[0];

    char* 	name;
    GDBFile	dbf;
    if(argc==4) {
	if(strcmp(argv[1], "-i") ==0) { 
	    index = atoi(argv[2]);
	    name = argv[3];
	}
    }
    else 
	name = argv[1];

    if (dbf.openDBF(name) != GOk) 
	msgFail("can't open dbf file");
    cout<<dbf;

    dbfDump(&dbf, index);
}
    
