//
// This file dumps the spatial data records in a shapefile onto a console.
// Each record is a single line of comma-delimited coordinates in ascii
// format.
// $Id: shapedump.cpp,v 1.1 1999/02/17 01:48:13 qian Exp $
//
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "gadt_point.h"
#include "gshapefile.h"
#include "gdbf.h"

void shapeDump(GShapeFile* shp, int idx)
{
    GSpatial	*rec;
    int 	n_points, i, j, n, s, e;
    double	*coords;

    GRect       mbr;
    if(idx<0) { //dump all
	s = 0; e = shp->numRecords();
    } else {
	s = idx; e=idx+1;
    }
    printf("\n");	
    for(i=s; i<e; i++) {
	rec = shp->getShapeRec(i);
	if(!rec) continue;	//should complain
	switch(rec->type()) {
	case _Point:	printf("%.4f, %.4f\n", 
			       ((GPoint*)rec)->x, 
			       ((GPoint*)rec)->y); break;
	case _Arc:
	    for(j=0; j<((GArc*)rec)->numBranches(); j++) {
		n_points = ((GArc*)rec)->getBranch(j, coords);
		if(j==0) printf("%.4f, %.4f,  ", coords[0], coords[1]);
		else printf("        %.4f, %.4f,  ", coords[0], coords[1]); 
		for(n=1; n<n_points-1; n++) 
		    printf("%.4f, %.4f,  ", coords[n*2+0], coords[n*2+1]);
		printf("%.4f, %.4f\n", coords[n*2+0], coords[n*2+1]);
	    }
	    break;	
	case _Polygon:
	    ((GPolygon*)rec)->mbr(mbr);
 	    cout<<mbr<<endl;
	    /*
	    for(j=0; j<((GPolygon*)rec)->numRings(); j++) {
		n_points = ((GPolygon*)rec)->getRing(j, coords);
		if(j==0) printf("%.4f, %.4f,  ", coords[0], coords[1]);
		else printf("        %.4f, %.4f,  ", coords[0], coords[1]); 
		for(n=1; n<n_points-1; n++) 
		    printf("%.4f, %.4f,  ", coords[n*2+0], coords[n*2+1]);
		printf("%.4f, %.4f\n", coords[n*2+0], coords[n*2+1]);
	    }
	    */
	    break;	
	default:
	    printf("unsupported data type!");
	    break;
	}
    }
}
		    
	    
main(int argc, char* argv[])
{
    if(argc <2) {
    err:	
	cerr<<"Usage: shapedump [-i record_idx] <shape file>\n";
	exit(1);
    }
    
    int index = -1;

    char* 	name;
    GShapeFile	shp;
    GDBFile	dbf;
    if(argc==4) {
	if(strcmp(argv[1], "-i") ==0) { 
	    index = atoi(argv[2]);
	    name = argv[3];
	}
    }
    else 
	name = argv[1];

    if (shp.openShapeFile(name) != GOk) 
	msgFail("can't open shapefile");
    cout<<shp;
    dbf.openDBF(name);
    cout<<dbf;

    shapeDump(&shp, index);
}
    
