//
// This file uses the Shapefile utility to check an ArcView shape file.
// $Id: shapeinfo.cpp,v 1.3 1998/07/10 04:40:27 qian Exp $
//
#include <dirent.h>
#include <string.h>

#include "gadt_rect.h"
#include "gshapefile.h"
#include "gdbf.h"


// count the total number of records in all
// shapefiles under given dir
int countAll(const char* dir) 
{
    DIR 		*dirp;
    struct dirent 	*direntp;
    
    GShapeFile		shp;
    long		total=0;
    char		path[256];
    GRect		universe_mbr, mbr ;
    double		xl,yl,xh,yh;
    int			n=0;
    dirp = opendir(dir);
    if(!dirp) {
	msgWarn("directory invalid");
	return 0;
    }
    
    while ( (direntp = readdir( dirp )) != NULL ) {
	if(strstr(direntp->d_name, ".shp")) {
	    memset(path, 0, 256);
	    if(strcmp(dir, ".")==0) strcpy(path, direntp->d_name);
	    else {
		strcpy(path, dir);
		strcat(path, "/");
		strcat(path, direntp->d_name);
	    }
	    if ( shp.openShapeFile(path) != GOk) {
		msgWarn("can't open shapefile");
		return 0;
	    }
	    shp.bndRect(xl,yl,xh,yh);
	    if(yl==0) yl = universe_mbr.getYL();
	    if(xh==0) xh = universe_mbr.getXH();
	    mbr.set(xl,yl,xh,yh);	
	    if(n==0) universe_mbr.set(xl,yl,xh,yh);
	    else 	
		universe_mbr.enlarge(mbr);
	    
	    cout<<direntp->d_name<<" "<<shp.numRecords();
	    cout<<" mbr="<<mbr<<endl;
	    
	    total += shp.numRecords();
	    n++;
	}
    }
    cout<<"---------------------------------------------------------------------------\n";
    cout<<"total number of records: "<<total<<", universe MBR="<<universe_mbr<<endl;
    return total;
}

main(int argc, char* argv[])
{
    if(argc <2) {
    err:	
	cerr<<"Usage: shapeinfo [-n,-a] <shape file>|<dir>\n";
	cerr<<"	      option -n will only return number of records\n";
	cerr<<"	             -a will return total record number in given dir\n";
	exit(1);
    }
    
    GShapeFile	shp;
    GDBFile      dbf;

    if(argc==3) {
	if(strcmp(argv[1], "-n") ==0) { 
	    //return # of rec in one file
	    if (shp.openShapeFile(argv[2]) != GOk) 
		msgFail("can't open shapefile");
	    cout<<shp.numRecords()<<endl;
	    dbf.openDBF(argv[2]);
	    cout<<dbf;
	    exit(0);
	}
	else if(strcmp(argv[1], "-a") == 0 ) {
	    //return # of recs in all shape file in specfic dir
	    countAll(argv[2]);
	    exit(0);
	} else goto err;
    } else {
	if (shp.openShapeFile(argv[1]) != GOk) 
	    msgFail("can't open shapefile");
	cout<<"Information about "<<argv[1]<<":\n"<<shp<<endl;
	dbf.openDBF(argv[1]);
	cout<<dbf;
	exit(0);
    }
}

